# Created by pyp2rpm-3.3.5
%if 0%{?rhel}
%bcond_with docs
%else
%bcond_without docs
%endif
%bcond_without tests

%global pypi_name drgn

%global _description %{expand:
drgn (pronounced "dragon") is a debugger with an emphasis on programmability.
drgn exposes the types and variables in a program for easy, expressive
scripting in Python.}

Name:           python-%{pypi_name}
Version:        0.0.31+16.g6358b6b9
Release:        1.20250521173638839940.pr466.16.g6358b6b9%{?dist}
Summary:        Programmable debugger

License:        LGPL-2.1-or-later
URL:            https://github.com/osandov/drgn
Source0:        drgn-0.0.31+16.g6358b6b9.tar.gz

BuildRequires:  python3-devel
BuildRequires:  python3dist(setuptools)
%if %{with docs}
BuildRequires:  sed
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3-docs
BuildRequires:  graphviz
%endif
%if %{with tests}
BuildRequires:  python3dist(pytest)
%endif
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  bzip2-devel
BuildRequires:  elfutils-devel
BuildRequires:  elfutils-debuginfod-client-devel
BuildRequires:  libkdumpfile-devel
BuildRequires:  zlib-devel
BuildRequires:  xz-devel
# These are needed when building from git snapshots
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool

%description %{_description}

%package -n     %{pypi_name}
Summary:        %{summary}
Recommends:     elfutils-debuginfod-client

%description -n %{pypi_name} %{_description}

%if %{with docs}
%package -n %{pypi_name}-doc
Summary:        %{pypi_name} documentation
BuildArch:      noarch
Requires:       python3-docs

%description -n %{pypi_name}-doc %{_description}

This package contains additional documentation for %{pypi_name}.
%endif

%prep
%autosetup -n drgn-0.0.31+16.g6358b6b9 -p1
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info
%if %{with docs}
# Use local intersphinx inventory
sed -r \
    -e 's|https://docs.python.org/3|%{_docdir}/python3-docs/html|' \
    -i docs/conf.py
%endif
# Ensure version is always set, even when building from git snapshots
if [ ! -f drgn/internal/version.py ]; then
  echo '__version__ = "%{version}"' > drgn/internal/version.py
fi

%build
# verbose build
V=1 %py3_build

%if %{with docs}
# generate html docs
PYTHONPATH=${PWD} sphinx-build-3 docs html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%py3_install
mkdir -p %{buildroot}%{_datadir}/drgn
cp -PR contrib tools %{buildroot}%{_datadir}/drgn

%if %{with tests}
%check
%pytest
%endif

%files -n %{pypi_name}
%license COPYING
%license LICENSES
%doc README.rst
%{_bindir}/drgn
%{_datadir}/drgn
%{python3_sitearch}/_%{pypi_name}.pyi
%{python3_sitearch}/_%{pypi_name}.cpython*.so
%{python3_sitearch}/%{pypi_name}
%{python3_sitearch}/_%{pypi_name}_util
%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%if %{with docs}
%files -n %{pypi_name}-doc
%license COPYING
%license LICENSES
%doc html
%endif

%changelog
* Wed May 21 2025 Packit <hello@packit.dev> - 0.0.31+16.g6358b6b9-1.20250521173638839940.pr466.16.g6358b6b9
- tests: Add test for .gnu_debugdata symbols (Stephen Brennan)
- elf_symtab: add support for .gnu_debugdata (Stephen Brennan)
- elf_symtab: support multiple tables per module (Stephen Brennan)
- libdrgn: elf_symtab: fix overriding partial table with full table (Omar Sandoval)
- docs: clarify Program.symbol() tie-breaking (Omar Sandoval)
- libdrgn: elf_symtab: fix comment about skipping local symbols (Omar Sandoval)
- libdrgn: python: add missing garbage collection support (Omar Sandoval)
- libdrgn: python: check correct pointer in StackTrace_dealloc() (Omar Sandoval)
- libdrgn: python: fix reference leak for held types (Stephen Brennan)
- contrib/pp_leak: add page_pool leak debug scripts (Dragos Tatulea)
- helpers: add is_pp_page helper (Dragos Tatulea)
- drgn.helpers.linux.fs: skip cursors in for_each_mount() (Stephen Brennan)
- vmtest.rootfsbuild: install check (Omar Sandoval)
- cli: don't enter interactive mode for empty -e argument (Omar Sandoval)
- tests: fix issues with CLI test error handling (Omar Sandoval)
- tests: fix deserialize_struct64 tests on i386 (Omar Sandoval)
